/**
 * 
 */
package org.netkernel.layer0.bnf;

import org.netkernel.layer0.util.PairList;
import org.netkernel.layer0.util.XMLUtils;
import org.w3c.dom.*;

/**
 * @author Tony Butterfield
 *
 */
public class GrammarParseException extends Exception
{
	private static final long serialVersionUID = -7670584033425850973L;
	
	private final PairList mValidationErrors;
	
	/**
	 * @param message
	 */
	public GrammarParseException(PairList aValidationErrors)
	{	mValidationErrors=aValidationErrors;
	}
	
	public GrammarParseException(String aMessage)
	{	super(aMessage);
		mValidationErrors=null;
	}
	
	public GrammarParseException(Element aLocation, Object aErrorObject)
	{	mValidationErrors=new PairList(1);
		mValidationErrors.put(aLocation,aErrorObject);
	}
	
	public String getMessage()
	{
		if (mValidationErrors!=null)
		{	StringBuffer sb=new StringBuffer(128);
			sb.append("GrammarParseException( ");
			for (int i=0; i<mValidationErrors.size(); i++)
			{	sb.append('[');
				sb.append(mValidationErrors.getValue2(i));
				sb.append("] at [");
				sb.append(XMLUtils.getPathFor((Node)mValidationErrors.getValue1(i)));
				sb.append("] ");
			}
			sb.append(')');
			return sb.toString();
		}
		else
		{	return super.getMessage();
		}
	}
	
	/** Each pair should be org.w3c.dom.Node, String
	 * @return
	 */
	public PairList getValidationErrors()
	{	return mValidationErrors;
	}

}
