package org.netkernel.layer0.meta.impl;

import org.netkernel.layer0.meta.IPrototypeMeta;
import org.netkernel.layer0.meta.IPrototypeParameterMeta;
import org.netkernel.layer0.urii.SimpleIdentifierImpl;
import org.netkernel.layer0.util.Utils;
import org.netkernel.urii.IIdentifier;


public class DefaultPrototypeMeta extends MetaRepresentationImpl implements IPrototypeMeta
{
	private final Class mImplementation;
	private final IIdentifier mIdentifier;
	
	public DefaultPrototypeMeta(Class aRepresentationClass)
	{	this(aRepresentationClass,aRepresentationClass.getName());
	}
	
	public DefaultPrototypeMeta(Class aRepresentationClass, String aIdentifier)
	{	super(Utils.shortClassName(aRepresentationClass),null,null,null);
		mImplementation=aRepresentationClass;
		mIdentifier = new SimpleIdentifierImpl(aIdentifier);
	}
	
	public final Class getImplementation()
	{	return mImplementation;
	}

	public final IIdentifier getIdentifier()
	{	return mIdentifier;
	}

	public IPrototypeParameterMeta[] getParameters()
	{	return NOPARAM;
	}

}