package org.netkernel.layer0.representation.impl;

import java.util.*;

import org.netkernel.layer0.representation.IHDSIndex;
import org.netkernel.layer0.representation.IHDSIndexSpecification;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSNodeList;
import org.netkernel.layer0.util.MultiMap;

public class HDSIndex implements IHDSIndex
{
	private final MultiMap mMap;
	
	public HDSIndex(IHDSNode aContextNode, IHDSIndexSpecification aSpecification)
	{	IHDSNodeList nodes=aSpecification.getNodesToIndex(aContextNode);
		mMap = new MultiMap(nodes.size(),2);
		for (IHDSNode node : nodes)
		{	Object key = aSpecification.getKeyValue(node);
			mMap.put(key, node);
		}			
	}
	
	public IHDSNodeList get(Object aKey)
	{	IHDSNodeList result;
		List<IHDSNode> nodes=mMap.get(aKey);
		int size=nodes.size();
		if (size>1)
		{	result = new HDSNodeListImpl(nodes);
		}
		else if (size==0)
		{	result = HDSNodeListImpl.EMPTY;
		}
		else
		{	result = new HDSSingleNodeList(nodes.get(0));
		}
		return result;
	}
}
