package org.netkernel.layer0.urii;

import org.netkernel.layer0.bnf.IPartEncoding;
import org.netkernel.layer0.util.Utils;

public class ActiveURIEncoding implements IPartEncoding
{
	public static final ActiveURIEncoding INSTANCE=new ActiveURIEncoding();
	
	public String decode(String aInput)
	{	StringBuffer sb=new StringBuffer(aInput.length());
		int length = aInput.length();
		for (int i=0; i<length; i++)
		{	char c = aInput.charAt(i);
			if (c=='%')
			{	try
				{	int c1 = Utils.toHex(aInput.charAt(i+1));
					int c2 = Utils.toHex(aInput.charAt(i+2));
					char c3 = (char)((c1<<4) + c2);
					switch (c3)
					{	case ' ':
						case '%':
						case ':':
						case '#':
						case '+':
						case '@':
						case '=':
							c=c3;
							i+=2;
							break;
					}
				}
				catch (IllegalArgumentException e)
				{
				}
			}
			sb.append(c);
		}
		String result;
		if (sb.length()!=aInput.length())
		{	result=sb.toString();
		}
		else
		{	result=aInput;
		}
		return result;
	}
	
	public String encode(String aInput)
	{	char[] input = aInput.toCharArray();
		int length=input.length;
		char [] output = new char[length*3];
		int l=0;
		for (int i=0; i<length; i++)
		{	char c=input[i];
			switch (c)
			{	case ' ': output[l++]='%'; output[l++]='2'; output[l++]='0'; break;
				case '%': output[l++]='%'; output[l++]='2'; output[l++]='5'; break;
				case ':': output[l++]='%'; output[l++]='3'; output[l++]='A'; break;
				case '#': output[l++]='%'; output[l++]='2'; output[l++]='3'; break;
				case '+': output[l++]='%'; output[l++]='2'; output[l++]='B'; break;
				case '@': output[l++]='%'; output[l++]='4'; output[l++]='0'; break;
				case '=': output[l++]='%'; output[l++]='3'; output[l++]='D'; break;
				default: output[l++]=c;
			}
		}
		if (l!=length)
		{	return new String(output,0,l);
		}
		else
		{	return aInput;
		}
	}
}
